routes/web.php
<?php

use App\Http\Controllers\AdminpanelController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ContentController;
use App\Http\Controllers\DocumentController;
use App\Http\Controllers\TrainingController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\UserviewController;
use Illuminate\Support\Facades\Route;

Route::get('/', [UserviewController::class,'index']);

Route::get('/home', [UserviewController::class,'home']);
Route::get('/all-contents', [UserviewController::class,'allContents']);
Route::get('/content-documents/{content}', [UserviewController::class,'contentDocuments']);


Route::get('/documents-lists', [UserviewController::class,'documentsLists']);
Route::get('/trainings-lists', [UserviewController::class,'trainingsLists']);
Route::get('/trainings-details/{training}', [UserviewController::class,'trainingsDetails']);

// Route::get('/details', function () {
//     $directory = __DIR__ .'/../public/storage/media';

//     $files = File::directories($directory);
//     dd($files);
//     return view('userview.details', [
//         'files' => $files,
//     ]);
// });

Route::prefix('admin')->group(function () {
    Route::get('/dashboard', [AdminpanelController::class,'dashboard']);
    Route::resource('/contents', ContentController::class);
    Route::resource('/trainings', TrainingController::class);
    Route::get('/courses/create/sub-folder', [TrainingController::class,'createSubFolder']);
    Route::get('/train/choosetitle', [TrainingController::class,'choosetitle'])->name('choosetitle');
    Route::resource('/users', UserController::class);
    Route::resource('/documents', DocumentController::class);
});


Route::get('/checkSlugDoc', [DocumentController::class,'checkSlugDoc'])->name('checkSlugDoc');
Route::get('/checkSlugTraining', [TrainingController::class,'checkSlugTraining'])->name('checkSlugTraining');

app/Models/Training.php
<?php

namespace App\Models;

use \Cviebrock\EloquentSluggable\Sluggable;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Training extends Model
{
    use HasFactory,Sluggable;
    protected $guarded = [];

    /**
      * Return the sluggable configuration array for this model.
      *
      * @return array
      */
    public function sluggable(): array
    {
        return [
            'slug' => [
                'source' => 'file_name'
            ]
        ];
    }
    public function subFolders()
    {
        return $this->belongsTo(SubFolder::class, 'sub_folder_id');
    }
    public function Content()
    {
        return $this->belongsTo(Content::class);
    }

}

app/Http/Controllers/TrainingController.php
<?php

namespace App\Http\Controllers;

use App\Models\Content;
use App\Models\SubFolder;
use App\Models\Training;
use Illuminate\Http\Request;

use \Cviebrock\EloquentSluggable\Services\SlugService;
use Illuminate\Validation\Rule;

class TrainingController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('adminview.trainings.upload', [
            'subfolders'=>SubFolder::where('content_id', request()->title)->get(),
        ]);

    }

    public function choosetitle()
    {
        return view('adminview.trainings.chooseTitle', [
             'titles'=>Content::where('type', 'trainings')->get(),
        ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $training = $request->validate([
             'file_name' => ['required', 'min:4'],
            'slug' => ['required'],
            'file'=> ['required'],
         ]);


        $title = Content::select('slug')->where('id', $request->title)->first();

        if($request->sub_folder_id == null) {
            $store_path = "trainings/$title[slug]";
        } else {
            $sub_folder = SubFolder::select('slug')->where('id', $request->sub_folder_id)->first();
            $store_path = "trainings/$title[slug]/$sub_folder[slug]";

        }
        $training['content_id'] = $request->title;
        $training['description'] = $request->description;
        $training['sub_folder_id'] = $request->sub_folder_id;
        $training['uploaded_by'] = 'thae nandar soe';

        $file_name = request()->file('file')->getClientOriginalName();


        $training['file'] = request()->file('file')->storeAs("$store_path", $file_name) ;

        Training::create($training);

        return redirect()->back();

    }

    /**
     * Display the specified resource.
     */
    public function show(Training $training)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Training $training)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Training $training)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Training $training)
    {
        //
    }

    public function createSubFolder()
    {
        return view('adminview.trainings.createSubfoler', [
            'contents' => Content::where('type', 'trainings')->get(),
        ]);
        // return view('adminview.trainings.createSubfoler', [
        //     'trainings' => Training::all(),
        // ]);
    }
    public function checkSlugTraining(Request $request)
    {

        $slug = SlugService::createSlug(Training::class, 'slug', $request->file_name);
        return response()->json(['slug'=>$slug]);
    }
}

resources/views/adminview/trainings/chooseTitle.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Upload Trainings" />

    <section class="section">
        <div class="row">
            <div class="col-lg-12">

                <div class="card">
                    <div class="card-body py-5">

                        <!-- Floating Labels Form -->
                        <form class="row g-3" action="{{route('trainings.create')}}" method="get">
                            @csrf
                            <div class="col-md-6">
                                <div class="form-floating">
                                    <select class="form-select shadow-none" name="title" id="title"
                                        aria-label="Sub Title">
                                        <option value="" selected> -- Select--</option>

                                        @foreach ($titles as $title)
                                        <option value="{{$title->id}}">{{$title->name}}</option>

                                        @endforeach
                                    </select>
                                    <label for="title">Title <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-12">
                                <div class="form-floating ">
                                    <button type="submit" class="btn btn-primary btn-get-started">Next <i
                                            class="bi bi-arrow-right"></i></button>
                                </div>
                            </div>

                        </form><!-- End floating Labels Form -->

                    </div>
                </div>

            </div>
        </div>
    </section>

</main><!-- End #main -->

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"
    integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>

@endsection

resources/views/adminview/trainings/createSubfoler.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Create Sub-Title" />

    <section class="section">
        <div class="row">
            <div class="col-lg-12">

                <div class="card">
                    <div class="card-body py-5">

                        <!-- Floating Labels Form -->
                        <form class="row g-3" action="#" method="post" enctype="multipart/form-data">
                            @csrf
                            <div class="col-md-6">
                                <div class="form-floating">
                                    <select class="form-select shadow-none" name="content_id" id="content_id"
                                        aria-label="Content">
                                        <option selected> -- Select--</option>
                                        @foreach ($contents as $content)
                                        <option value="{{$content->id}}">{{$content->name}}</option>

                                        @endforeach

                                    </select>
                                    <label for="content_id">Content <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-floating">
                                    <input type="text" class="form-control shadow-none" name="name" id="name"
                                        placeholder="Name" readonly>
                                    <label for="name">Name <span>*</span> </label>
                                </div>
                            </div>


                            <div class="col-md-6">
                                <div class="form-floating d-flex justify-content-start align-items-center">
                                    <button type="submit" class="btn btn-primary btn-get-started">Create <i
                                            class="bi bi-upload"></i></button>
                                </div>
                            </div>

                        </form><!-- End floating Labels Form -->

                    </div>
                </div>

            </div>
        </div>
    </section>

</main><!-- End #main -->

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"
    integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function(){
    $('#title').change(function(e){
        $.get('{{ route("checkSlugDoc") }}',
            {'title':$(this).val(),},
            function (data){
                $('#slug').val(data.slug);
            }
        );
    });
    });

</script>
@endsection

resources/views/adminview/trainings/upload.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Upload Trainings" />

    <section class="section">
        <div class="row">
            <div class="col-lg-12">

                <div class="card">
                    <div class="card-body py-5">

                        <!-- Floating Labels Form -->
                        <form class="row g-3" action="{{route('trainings.store')}}" method="post"
                            enctype="multipart/form-data">
                            @csrf
                            <div class="col-md-12">
                                <div class="form-floating">
                                    <input type="text" class="form-control shadow-none" name="file_name" id="file_name"
                                        required placeholder="File Name">
                                    <label for="file_name">File Name <span>*</span> </label>
                                </div>
                                <x-backend.form_error name="file_name" />
                            </div>

                            <div class="col-md-12">
                                <div class="form-floating">
                                    <input type="text" class="form-control shadow-none" name="slug" id="slug"
                                        placeholder="Slug" readonly>
                                    <label for="slug">Slug <span>*</span> </label>
                                </div>
                            </div>
                            <x-backend.form_error name="slug" />

                            <input type="hidden" name="title" value="{{request()->title}}">




                            <div class="col-md-6">
                                <div class="form-floating">
                                    <input type="file" class="form-control shadow-none" name="file" id="file"
                                        placeholder="File" required>
                                </div>
                                <x-backend.form_error name="file" />
                            </div>
                            <div class="col-md-6">
                                <div class="form-floating mb-3">
                                    <select class="form-select shadow-none" name="sub_folder_id" id="sub_folder_id"
                                        aria-label="Sub Title">
                                        <option value="" selected> -- Select--</option>

                                        @foreach ($subfolders as $sub)
                                        <option value="{{$sub->id}}">{{$sub->name}}</option>

                                        @endforeach
                                    </select>
                                    <label for="sub_folder_id">Sub Title </label>
                                </div>
                                <x-backend.form_error name="sub_folder_id" />
                            </div>

                            <div class="col-md-12">
                                <div class="form-floating">
                                    <textarea class="form-control shadow-none" placeholder="Description"
                                        name="description" id="description" style="height: 150px;"></textarea>
                                    <label for="description">Description </label>
                                </div>
                                <x-backend.form_error name="description" />
                            </div>


                            <div class="col-md-4">
                                <div class="form-floating ">
                                    <button type="submit" class="btn btn-primary btn-get-started">Upload <i
                                            class="bi bi-upload"></i></button>
                                </div>
                            </div>

                        </form><!-- End floating Labels Form -->

                    </div>
                </div>

            </div>
        </div>
    </section>

</main><!-- End #main -->

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"
    integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function(){
    $('#file_name').change(function(e){
        $.get('{{ route("checkSlugTraining") }}',
            {'file_name':$(this).val(),},
            function (data){
                $('#slug').val(data.slug);
            }
        );
    });
    });

</script>
@endsection